import os, asyncio
from dotenv import load_dotenv

load_dotenv()

from fastapi import FastAPI
from fastapi.middleware.cors import CORSMiddleware
from src.modules.router import router as modulesrouter
from src.variables.router import router as variablesrouter

import scripts.timer



app = FastAPI(root_path="/api")

app.add_middleware(
    CORSMiddleware,
    allow_origins=["*"],  # Can also use ["*"] to allow all origins
    allow_credentials=True,  # Allow cookies or authentication credentials
    allow_methods=["*"],  # Allow all HTTP methods
    allow_headers=["*"],  # Allow all headers
)

app.include_router(router=modulesrouter)
app.include_router(router=variablesrouter)
